<script lang="ts">
import {
  defineComponent,
  ref,
  watch,
  PropType,
  inject,
  useId,
  onUnmounted,
} from 'vue';
import { htmlIds } from '@new-jira-clone/ui/src/constants/id';
import JOverlay from '@new-jira-clone/ui/src/components/overlay/JOverlay';
import JFocusTrap from '@new-jira-clone/ui/src/components/overlay/JFocusTrap';
import { DialogType } from '@new-jira-clone/ui/src/composables/store/useDialogsStore';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import JDialogBody from './JDialogBody.vue';

const inputEmitName = 'update:modelValue';

type DeviceEvent = MouseEvent | KeyboardEvent; 

export default defineComponent({
  name: 'JDialog',
  components: {
    JFocusTrap,
    JOverlay,
    JDialogBody,
  },
  props: {
    type: {
      type: String as PropType<DialogType>,
      default: 'modal',
    },
    modelValue: {
      type: Boolean,
      default: false,
    },
    zIndex: {
      type: Number,
      default: null,
    },
    focusOnClose: {
      type: Boolean,
      default: true,
    },
  },
  emits: [inputEmitName],
  setup(props, { emit }) {
    const $dialog = inject('$dialog') as DialogPlugin;

    const dialogModel = ref(false);
    const currentZIndex = ref(0);
    const componentId = useId();

    let activatorElement: HTMLElement | null = null;

    currentZIndex.value = $dialog.globalZIndex.value;

    const onDialogClick = async (): Promise<void> => {
      if (props.type === 'modal') return;

      if ($dialog.globalZIndex.value > currentZIndex.value) {
        $dialog.increaseZIndex();
        currentZIndex.value = $dialog.globalZIndex.value;
      }
    };

    const setFocus = () => {
      if (props.focusOnClose === false) return;
 
      setTimeout(async () => {
        if (activatorElement) {
          activatorElement.focus();
        }
      });
    }

    const setDialogModel = (value: boolean): void => {
      if (value) {
        $dialog.increaseZIndex();
        currentZIndex.value = $dialog.globalZIndex.value;
      }

      dialogModel.value = value;
      emit(inputEmitName, value);

      if (value === false) {
        setFocus();
      }
    };

    const open = (event: DeviceEvent): void => {
      if (event.target) {
        activatorElement = event.target as HTMLElement;  
      } else {
        activatorElement = event.currentTarget as HTMLElement;
      }

      setDialogModel(true);
    };

    const close = (): void => {
      setDialogModel(false);
    };

    watch(
      () => props.modelValue,
      (newVal: boolean) => {
        setDialogModel(newVal);
      },
    );

    watch(
      () => props.zIndex,
      (newZIndex: number | null) => {
        if (newZIndex) {
          currentZIndex.value = newZIndex;
        }
      },
      {
        immediate: true,
      },
    );

    onUnmounted(() => {
      activatorElement = null;
    });

    return {
      onDialogClick,
      currentZIndex,
      dialogModel,
      setDialogModel,
      open,
      close,
      htmlIds,
      componentId,
    };
  },
});
</script>

<template>
  <slot
    name="activator"
    aria--haspopup="dialog"
    @click="open"
    @keydown.space="open"
  />

  <Teleport :to="htmlIds.overlayRoot">
    <JOverlay
      v-if="type === 'modal' && dialogModel"
      :model-value="dialogModel"
      :z-index="currentZIndex"
      @update:model-value="close"
    />

    <Transition name="scale">
      <div
        v-if="dialogModel"
        class="j-dialog-container"
        :style="{ zIndex: currentZIndex }"
        :class="{ 'non-modal': type === 'nonModal' }"
        @mousedown="onDialogClick"
        @keydown.esc.stop="close"
      >
        <JFocusTrap :value="dialogModel" />
        <template v-if="type === 'modal'">
          <JDialogBody>
            <slot />
          </JDialogBody>
        </template>
        <slot v-else />
      </div>
    </Transition>
  </Teleport>
</template>

<style lang="scss" scoped>
.j-dialog-container {
  display: flex;
  justify-content: center;
  align-items: center;
  position: absolute;
  width: 100%;
  height: 100%;
  pointer-events: none;
  transition: 300ms cubic-bezier(0.25, 0.8, 0.25, 1), z-index 1ms;

  &.modal {
    overflow: auto;
  }

  &.non-modal {
    overflow: hidden;
  }

  :deep {
    & > * {
      pointer-events: auto;
    }
  }
}

.scale-enter-from,
.scale-leave-to {
  opacity: 0;

  &:not(.non-modal) {
    transform: scale3d(0.4, 0.4, 0.4);
  }

  :deep {
    & > * {
      pointer-events: none;
    }
  }
}
</style>
